* 1 "gtdump.F"
* PACKAGE GTDUMP   
*********************************************************************
      PROGRAM GTDUMP
*

* 1 "../../include/gtsinc.F"
* PACKAGE GTSINC  
*****************************************************************
      PARAMETER  ( IDIM=256 )
      PARAMETER  ( JDIM=128 )
      PARAMETER  ( KDIM=17  )
      PARAMETER  ( IJKDIM=IDIM*JDIM*KDIM )
      
* 6 "gtdump.F"

* 1 "../../include/gzsize.F"
      INTEGER    NCC, NDC, NED, NFILN
      PARAMETER  ( NCC=16, NDC=64, NED=8 )
      PARAMETER  ( NFILN=100 )
* 7 "gtdump.F"

* 1 "../../include/gpainc.F"
*"ɽ Ĵ´ؿΰ GTOOL3(GPAINC)
*
*" 91/01/17 ¸  
*
*
**********************************************************************
*"      << Ĵ´ؿΰ >>
**********************************************************************
      PARAMETER
     & ( MMAXC = IDIM/3,
     &   LMAXC = MMAXC,
     &   NMAXC = MMAXC,
     &   MINTC = 1,
     &   NMLC  = NMAXC-LMAXC,
     &   NMDIMC= (MMAXC/MINTC+1)*(2*(NMAXC+1)-LMAXC)-NMLC*(NMLC+1) )
*
      COMMON /GPAWK1/ WDATA
      COMMON /GPAWK2/ ZDATA
      COMMON /GPAWK3/ ZWORK
      COMMON /GPAWK4/ PNM
      COMMON /GPAWK5/ DPNM
      COMMON /GPAWK6/ TRIGS
      COMMON /GPAWK7/ IFAX
      COMMON /GPAWK8/ NMO
      COMMON /GPAWK9/ GW
      COMMON /GPAWKA/ COSLAT
      COMMON /GPAWKB/ QPNM
      COMMON /GPAWKC/ QDPNM
      COMMON /GPAWKD/ QGW
      COMMON /GPAWKE/ QSINLA
*
      REAL       WDATA ( NMDIMC*KDIM    )    
      REAL       ZDATA ( IDIM*JDIM*KDIM )    
      REAL       ZWORK ( IDIM*JDIM*KDIM )    
*
      REAL       PNM   ( JDIM*NMDIMC/2 )     
      REAL       DPNM  ( JDIM*NMDIMC/2 )     
      REAL       TRIGS ( 2*IDIM )            
      INTEGER    IFAX  ( 10 )                
*
      INTEGER    NMO   ( 2*(MMAXC+1)*(LMAXC+1) ) 
      REAL       GW    ( JDIM )              
      REAL       COSLAT( JDIM )              
*
      REAL*8     QPNM  ( (NMAXC+2)*(MMAXC+1) ) 
      REAL*8     QDPNM ( (NMAXC+2)*(MMAXC+1) ) 
      REAL*8     QGW   ( JDIM )              
      REAL*8     QSINLA( JDIM )              
*
      REAL       ER                          
      DATA       ER / 6370.E3 /
*
* 8 "gtdump.F"
      COMMON     /GMWORK/ MWORK
      REAL       MWORK  ( IJKDIM )
*
      CHARACTER  HHEAD( NDC )*(NCC)
      REAL       GDATA( IJKDIM )
*
      CHARACTER  HFILE( 1 ) *(NFILN)
      DATA       HFILE / 'gtool.out' /
      DATA       IFILE / 50 /
      DATA       JFILE / 60 /
*
      CHARACTER  OUT    *(NFILN)
      DATA       OUT    / 'gtool.out' /
      LOGICAL    POSI
      DATA       POSI  / .FALSE. /
      CHARACTER  ITEM   *(NCC)
      CHARACTER  UNIT   *(NCC)
      CHARACTER  TITLE  *(NCC*2)
      CHARACTER  DSET   *(NCC)
      CHARACTER  EDIT   *(NCC)
      CHARACTER  ETTL   *(NCC)
      DATA       ITEM, UNIT, TITLE, DSET, EDIT, ETTL /6*' '/
      LOGICAL    GRESET
      DATA       GRESET / .FALSE. /
      LOGICAL    HELP
      DATA       HELP   / .FALSE. /
*
      EXTERNAL   FILT
*     
      NAMELIST  /OPTION/ OUT, POSI,
     &                   ITEM, UNIT, TITLE, DSET, EDIT, ETTL, GRESET,
     &                   HELP, HFILE
*
      CALL OPTARG ( 91, 'OPTION', 'HFILE', NOPT, NFILE )
      READ (91,OPTION,IOSTAT=IOS)
      CLOSE(91)
      IF ( IOS.NE.0 .OR. HELP ) THEN
         WRITE(6,OPTION)
         STOP
      ENDIF
*
      CALL GURNTF ( HFILE( 1 ), OUT  , '$GTTMPDIR/gtool.in' )
*
      CALL GTOPEN
      CALL GTSIZE ( HHEAD, IJKDIM )
      CALL GMSIZE ( IJKDIM  )
*
      CALL GFROPN ( IFILE , HFILE( 1 ) )
      CALL GFWOPN ( JFILE ,  OUT )
*
      IL=LENC(OUT)
      WRITE (0,*) 'output='//OUT(1:IL)
*
      IF ( POSI ) CALL SETPOS
*
 1100 CONTINUE
         CALL   GFREAD
     O        ( HHEAD , GDATA , IEOD  ,
     I          IFILE , 1               )
*
         IF ( IEOD .EQ.0 ) THEN
*
            CALL GMCAL1
     I         ( FILT  ,
     M           HHEAD , GDATA ,
     I           EDIT  , ETTL  )
*
            IF ( ITEM .NE. ' ' ) THEN
               CALL GHCSET( HHEAD , 'ITEM', ITEM )
            ENDIF
            IF ( UNIT .NE. ' ' ) THEN
               CALL GHCSET( HHEAD , 'UNIT', UNIT )
            ENDIF
            IF ( TITLE .NE. ' ' ) THEN
               CALL GHCSTS( HHEAD , 'TITL', TITLE )
            ENDIF
            IF ( DSET .NE. ' ' ) THEN
               CALL GHCSET( HHEAD , 'DSET', DSET )
            ENDIF
            IF ( GRESET ) THEN
               CALL GHRSGP( HHEAD  )
            ENDIF
*
            CALL  GFWRIT
     I                 ( HHEAD , GDATA ,
     I                   JFILE , 1     , 0       )
*
      GOTO 1100
         ENDIF
*
      STOP
      END
*********************************************************************
      SUBROUTINE FILT
     I         ( HH    , GDATA , 
     O           HHF   , GDATAF,
     I           IMAX  , JMAX  , KMAX  )
*
      CHARACTER  HH     ( * )*(*)        
      REAL       GDATA  ( * )            
      CHARACTER  HHF    ( * )*(*)        
      REAL       GDATAF ( * )            
*
      LOGICAL    OPOSI
      DATA       OPOSI / .FALSE. /
      SAVE       OPOSI
*
      PARAMETER  ( IDIM=3, JDIM=2, KDIM=1 )

* 1 "../../include/gpainc.F"
*"ɽ Ĵ´ؿΰ GTOOL3(GPAINC)
*
*" 91/01/17 ¸  
*
*
**********************************************************************
*"      << Ĵ´ؿΰ >>
**********************************************************************
      PARAMETER
     & ( MMAXC = IDIM/3,
     &   LMAXC = MMAXC,
     &   NMAXC = MMAXC,
     &   MINTC = 1,
     &   NMLC  = NMAXC-LMAXC,
     &   NMDIMC= (MMAXC/MINTC+1)*(2*(NMAXC+1)-LMAXC)-NMLC*(NMLC+1) )
*
      COMMON /GPAWK1/ WDATA
      COMMON /GPAWK2/ ZDATA
      COMMON /GPAWK3/ ZWORK
      COMMON /GPAWK4/ PNM
      COMMON /GPAWK5/ DPNM
      COMMON /GPAWK6/ TRIGS
      COMMON /GPAWK7/ IFAX
      COMMON /GPAWK8/ NMO
      COMMON /GPAWK9/ GW
      COMMON /GPAWKA/ COSLAT
      COMMON /GPAWKB/ QPNM
      COMMON /GPAWKC/ QDPNM
      COMMON /GPAWKD/ QGW
      COMMON /GPAWKE/ QSINLA
*
      REAL       WDATA ( NMDIMC*KDIM    )    
      REAL       ZDATA ( IDIM*JDIM*KDIM )    
      REAL       ZWORK ( IDIM*JDIM*KDIM )    
*
      REAL       PNM   ( JDIM*NMDIMC/2 )     
      REAL       DPNM  ( JDIM*NMDIMC/2 )     
      REAL       TRIGS ( 2*IDIM )            
      INTEGER    IFAX  ( 10 )                
*
      INTEGER    NMO   ( 2*(MMAXC+1)*(LMAXC+1) ) 
      REAL       GW    ( JDIM )              
      REAL       COSLAT( JDIM )              
*
      REAL*8     QPNM  ( (NMAXC+2)*(MMAXC+1) ) 
      REAL*8     QDPNM ( (NMAXC+2)*(MMAXC+1) ) 
      REAL*8     QGW   ( JDIM )              
      REAL*8     QSINLA( JDIM )              
*
      REAL       ER                          
      DATA       ER / 6370.E3 /
*
* 117 "gtdump.F"
*"    COMMON /GPAWK?/ WDATA , ZDATA , ZWORK ,
*"                    PNM   , DPNM  , TRIGS , IFAX  ,
*"                    NMO   , GW    , COSLAT,
*"                    QPNM  , QDPNM , QGW   , QSINLA
*"    REAL ER / 6370.E3 /
*
      IF ( OPOSI ) THEN
         DO 1000 IJK = 1, IMAX*JMAX*KMAX
            GDATA( IJK ) = MAX( GDATA(IJK), 0. )
 1000    CONTINUE 
      ENDIF
*
*"         < ؿν >
*
      CALL GPASPS
     I         ( IMAX  , JMAX  , KMAX  , ER    ,
     O           PNM   , DPNM  , TRIGS , IFAX  ,
     O           NMO   , GW    , COSLAT,
     O           LMAX  , MMAX  , NMAX  , MINT  ,
     O           NMDIM , JMXHF ,
     W           QPNM  , QDPNM , QGW   , QSINLA         )
*
*"         < ڥȥ >
*
      CALL SPG2W
     M         ( WDATA ,
     I           GDATA ,
     C           PNM   , NMO   , TRIGS , IFAX  , GW    ,
     F           '    ', 'POS' ,
     D           IMAX  , JMAX  , KMAX  , IMAX  , JMAX  ,
     D           LMAX  , MMAX  , NMAX  , MINT  , NMDIM , JMXHF ,
     W           ZDATA , ZWORK                                   )
*
      DO 1100 K = 1, KMAX
         DO 1100 N = 0, NMAX
            POW = 0.
            DO 1200 M = 0, MIN(MMAX,N)
               FF = FILTF(N,NMAX)
               NMI = (N-M)*(MMAX+1)*2 + M*2 
               WDATA(NMO(1+NMI)+(K-1)*NMDIM) 
     &       = WDATA(NMO(1+NMI)+(K-1)*NMDIM) * FF
               WDATA(NMO(2+NMI)+(K-1)*NMDIM)
     &       = WDATA(NMO(2+NMI)+(K-1)*NMDIM) * FF
 1200       CONTINUE 
 1100 CONTINUE 
*
*"         < ʻ᤹ͤ >
*
      CALL SPW2G
     M         ( GDATAF,
     I           WDATA ,
     C           PNM   , NMO   , TRIGS , IFAX  ,
     F           '    ', 'POS' ,
     D           IMAX  , JMAX  , KMAX  , IMAX  , JMAX  ,
     D           LMAX  , MMAX  , NMAX  , MINT  , NMDIM , JMXHF , 
     W           ZDATA , ZWORK                                   )
*
      RETURN
*======================================================================
      ENTRY      SETPOS
      OPOSI = .TRUE.
      RETURN
      END
*======================================================================
      REAL FUNCTION FILTF ( N, NMAX )
*
      INTEGER    N, NMAX
*
      FILTF = 1. - ( REAL(N)/REAL(NMAX) )**2
*
      RETURN
      END


